function [refinedEst, previewEst, previewPartition, corners, ...
    shimmeyPreviewEst, shimmeyPreviewPartition] = ...
  CTFPlateletApprox(x,smallestBoxSidelength,noiseType,pen,pen_w,numWedges)

% function [refinedEst, previewEst, previewPartition, corners, ...
%     shimmeyPreviewEst, shimmeyPreviewPartition] = ...
%   CTFPlateletApprox(x[,smallestBoxSidelength,noiseType,pen,pen_w,numWedges])
% 
% coarse-to-fine platelet multiscale image denoising
% 
% INPUTS:
% x - image, sqrt(n) X sqrt(n)
% smallestBoxSidelength - sidelength (in pixels) of a coarse resolution box
%     default: smallestBoxSidelength ~ sqrt(n^(1/3))
% noiseType - 'Poisson' or 'Gaussian'
% pen - penalty for each platelet fit
%     default (Poisson): pen = log(sum(x(:)));
%     default (Gaussian): pen = 2*noise_var*(1*log(n));
% pen_w - penalty for each wedged-platelet fit
%     default (Poisson): pen = (4/3)*log(sum(x(:)));
%     default (Gaussian): pen = 2*noise_var*((4/3)*log(n));
% numWedges - number of platelet orientations to consider per coarse resolution box
%     default: numWedges = n^(2/3);
% 
% OUTPUTS:
% refinedEst - denoised version of x
% previewEst - coarse resolution estimate
% previewPartition - coarse resolution partition
% corners - list of upper left corners of each cell in the preview partition
% shimmeyPreviewEst - 2nd coarse resolution estimate
% shimmeyPreviewPartition - 2nd coarse resolution partition
