function y = randp(x)
% RANDP  Generate random vector with Poisson density function.
% Usage: y = randp(x)

%       Author(s): K. Prager
%       Revision: 1.0  Date: 1996/03/05

y=zeros(size(x));
[m n] = size(x);

for i=1:m
   for j=1:n
      z = x(i,j);                           % De-reference vector value
      if (z <= 1.0e-10)
         y(i,j) = 0.0;                      % Too small to worry about
      elseif (z > 100.0)
          y(i,j) = (sqrt(z) * randn) + z;   % Gaussian approximation
      else                                  % "Random points in time" method
         s = 0.0;
         k = 0;
         while (s <= 1.0)
            s = s + ((-1.0 / z) * log(rand));
            k=k+1;
         end;
         k=k-1;
         y(i,j) = k;
      end;
   end;
end;

% function r=randp(lam);
% 
% r = zeros(size(lam));
% [rows,cols] = size(lam);
% lam = lam(:);
% j = (1:(rows*cols))';
% p = zeros(length(j),1);
% while ~isempty(j)
%   p = p-log(rand(length(j),1));
%   t = (p < lam(j));
%   j = j(t);
%   p = p(t);
%   r(j) = r(j) + 1;
% end
% 
% r(lam < 0) = NaN;
